﻿using System.Linq;
using Telerik.Windows.Controls.Map;

namespace DynamicLayerMapShapes
{
	public class DynamicSource : IMapDynamicSource
	{
		private MainPage mainPage;

		public DynamicSource(MainPage mainPage)
		{
			this.mainPage = mainPage;
		}

		public void ItemsRequest(object sender, ItemsRequestEventArgs e)
		{
			var layer = sender as DynamicLayer;

			Location upperLeft = e.UpperLeft;
			Location lowerRight = e.LowerRight;
			LocationRect rect = new LocationRect(upperLeft, lowerRight);
			rect.MapControl = this.mainPage.radMap;

			// request areas
			var query = from MapShape shape
						in this.mainPage.Shapes
						where this.ShouldBeAdded(rect, shape, layer)
						select shape;

			var shapes = query.ToList();
			e.CompleteItemsRequest(shapes);
		}

		private bool ShouldBeAdded(LocationRect rect, MapShape shape, DynamicLayer layer)
		{
			return !layer.Items.Contains(shape)
				&& rect.Intersect(shape.GeographicalBounds);
		}
	}
}
